#!/bin/bash
#
#
if [ -f "./install" ]
then
 rm ./install # tento soubor vznikne kdyz "make install" pred ./configure
fi

JMENO_ADR_LaT="/usr/local/share"
JMENO_ADR_INST="/usr/local/bin"
JMENO_ADR_MAN=${MANPATH:-/usr/local/man}
IFS=':' read -ra MAN <<< "$JMENO_ADR_MAN"
JMENO_ADR_MAN=${MAN[0]}

CURSES=				#  --with-curses
LPTHREAD=lpthread
MAKRO1=-D_REENTRANT		
MAKRO2=                         #  --with-posix
MAKRO3=--with-zobraz-test

CC=gcc                          # cc

#--------------------------------------------------------------------------#
# - Nasledujici obsah nechte nezmeneny ! ----------------------------------#   
#--------------------------------------------------------------------------#

. ./prgver

POM=
. ./znacek.sh

esc="\033["
zprava()
    {
	echo -e "${esc}47;34;1m${1}${esc}0m"
	return 0
    }

echoe1()
   {
	echo -e "${esc}40;33;1m${1}${esc}0m"
   }
echoe2()
   {
	echo -e "${esc}30;32;1m${1}${esc}0m"
   }
echoe3()
   {
	echo -e "${esc}47;31m${1}${esc}0m"
   }

#------------------------------------------------------------------------------

clear
echo ""
echo -e "${esc}40;37;1mVÍTEJTE V INSTALAČNÍM PROGRAMU${esc}0m"
echo ""
echoe1 "program:\t${NAZEV}"
echoe1 "verze:\t\t${VER}"
echoe1 "kompilátor:\t${CC}"
echo ""
echoe1 "     Tento program byl odladěn v OS OpenSuSE 13.1."
echo ""
echoe2 "     Nyní se  nainstaluje do Vašeho  počítače  program na  výuku psaní"
echoe2 "všemi deseti. Chcete-li, aby mohli program využívat všichni uživatelé,"
echoe2 "nainstalujte  jej  do  implicitně  vybraných  adresářů. Pokud  se  tak"
echoe2 "rozhodnete učinit, musíte být přihlašen jako root."
echoe2 "     Spustitelný soubor ${NAZEV1} můžete po instalaci kdykoli"
echoe2 "přemístit, ale ostatní soubory  (lekce, testy,  napoveda) ne. Pro tyto"
echoe2 "soubory bude ve Vámi vybraném adresáři vytvořen nový adresář se jménem"
echoe2 "./${NAZEV0}/${VER}/"
echo ""
echoe2 "     Pokud se Vám instalce z  nějakého důvodu nepodaří, zkuste  změnit"
echoe2 "hodnoty maker CURSES, MAKRO1 či MAKRO2 v  souboru  zdrojaky/install.sh"
echoe3 "MAKRO3 zrušte v případě, že máte možnost vytisknout si lekce." 
echoe2 "Hodnoty možných nastavení jsou uvedeny za komentářem #"
echo ""
echoe1 "Instalaci můžete ukončit stiskem kláves CTRL + C"
echoe2 "Pokračujte klávesou <ENTER> ..."
read POM

echo ""
echo "Zadejte  úplné jméno  adresáře, do kterého bude uložen  spustitelný soubor"
echo "\"${NAZEV}\", nebo . pro aktuální adresář,  nebo stiskněte  <ENTER>  pro"
echo "implicitní volbu. Nepoužívejte zkrácený zápis ~ (vlnovka) pro ${HOME} !"
echo -n "(Implicitně $JMENO_ADR_INST): "
read POM

if [ "$POM" != "" ]
then
	JMENO_ADR_INST=$POM
fi

case "$POM" in
   ".") 
   	JMENO_ADR_INST=`pwd`
   	;;
   [!/]*) echoe3 "ÚPLNÉ JMÉNO začíná lomítkem / :-)"
	  echoe3 "Spusťte instalaci znovu."
	  exit 1;;	
esac

if [ ! -d "$JMENO_ADR_INST" ]; then 
	echoe2 "POZOR: Adresář $JMENO_ADR_INST neexistuje, bude vytvořen"
fi

echo ""
echo "Zadejte úplné jméno adresáře, do kterého budou uloženy lekce a testy, nebo"
echo "stiskněte <ENTER> pro implicitní volbu.  (Opět nepoužívejte  ~  (vlnovku))"
echo -n "(Implicitně $JMENO_ADR_LaT): "
read POM

if [ "$POM" != "" ]
then
	JMENO_ADR_LaT=$POM
fi

case "$POM" in
  .*)
	echoe3 "Toto není ÚPLNÉ JMÉNO!"
	exit 1;;

  ~*) echoe3 "Toto není ÚPLNÉ JMÉNO!!"
	exit 1;;
[!/]*) echoe3 "ÚPLNÉ JMÉNO začíná lomítkem / :-)"
	exit 1;;	
esac

if [ ! -d "$JMENO_ADR_LaT" ]; then 
	echoe2 "POZOR: Adresář $JMENO_ADR_LaT neexistuje, bude vytvořen"
fi

echo Zadejte úplné jméno adresáře, do kterého budou uloženy manuálové stránky.
echo -n "(implicitně $JMENO_ADR_MAN): "
read POM

if [ "$POM" != "" ]
then
	JMENO_ADR_MAN=$POM
fi

case "$POM" in
   .*) 
	echoe3 "Toto není ÚPLNÉ JMÉNO!"
	exit 1;;
   [!/]*) echoe3 "ÚPLNÉ JMÉNO začíná lomítkem / :-)"
	  echoe3 "Spusťte instalaci znovu."
	  exit 1;;	
esac

if [ ! -d "$JMENO_ADR_MAN" ]; then 
	echoe2 "POZOR: Adresář $JMENO_ADR_MAN neexistuje, bude vytvořen"
fi

echo ""

zprava "Spoustim program ./configure --with-cc=$CC --with-lat-dir=$JMENO_ADR_LaT --with-prg-dir=$JMENO_ADR_INST --with-man-dir=$JMENO_ADR_MAN $CURSES $MAKRO2 $MAKRO3"

./configure --with-cc=$CC --with-lat-dir=$JMENO_ADR_LaT --with-prg-dir=$JMENO_ADR_INST --with-man-dir=$JMENO_ADR_MAN $CURSES $MAKRO2 $MAKRO3 &&

zprava "Překládám zdrojové kódy" &&
make clean && make all && make install &&

echo "" &&
echoe3 "Pro odinstalování programu použijte příkaz ${JMENO_ADR_INST}/${UNINSTALL}" &&
#echoe2 "Nastavte si na konzoli české fonty a můžete začít příkazem\n${JMENO_ADR_INST}/${NAZEV1} -w" &&
echoe2 "Nastavte si na konzoli české fonty a můžete začít příkazem\n${JMENO_ADR_INST}/psani -w" &&
zprava "Nezapomeňte si nainstalovat program luit!" &&
echoe2 "GRATULUJI! Instalace byla úspěšně ukončena." &&
exit 0

echo "INSTALACE NEBYLA ÚSPĚŠNÁ !!"
