/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne licenese GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor nactiinfo.c */

#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "struktury.h"
#include "lib.h"
#define SIZEKOMENTAR 100
#define SIZEKLAVESY 80
#define SIZEPISMENA 160
#define SIZENOVEPISMENA 40
int nacti_info_jedno(FILE *, type_informace *);

#ifdef PSANIPROFI
static type_informace info_lekce[MAXLEKCE], info_test[MAXTEST];
static char temp[255];

int nacti_info_vsecky_lekce()
{
    FILE *soubor;
    unsigned int i;

    for (i = 0; i < MAXLEKCE; i++) {
        /* toto musi byt nazacatku (pred prvnim return) */
        info_lekce[i].test = 0; /* je to lekce */
        info_lekce[i].komentar = (char *) malloc(SIZEKOMENTAR);
        if (info_lekce[i].komentar == NULL)
            info_lekce[i].komentar = temp;
        info_lekce[i].klavesy = (char *) malloc(SIZEKLAVESY);
        if (info_lekce[i].klavesy == NULL)
            info_lekce[i].klavesy = temp;
        info_lekce[i].pismena = (char *) malloc(SIZEPISMENA);
        if (info_lekce[i].pismena == NULL)
            info_lekce[i].pismena = temp;
        info_lekce[i].nove_pismena = (char *) malloc(SIZENOVEPISMENA);
        if (info_lekce[i].nove_pismena == NULL)
            info_lekce[i].nove_pismena = temp;
        info_lekce[i].zavislost_na = MAXTEST;
    }
    if ((soubor = fopen(jmeno_info_lekce(), "rt")) == NULL)
        return 1;

    do {
        if (!fscanf(soubor, "%255s", temp))
            return 1;
        if (strcmp("cislo:", temp))
            continue;
        if (!fscanf(soubor, "%4u", &i))
            return 1;
        if ((i > 0) && (i <= MAXLEKCE) && !feof(soubor)) {
            info_lekce[i - 1].cislo = i;
            if (nacti_info_jedno(soubor, &info_lekce[i - 1])) {
                fclose(soubor);
                return 1;
            }
            if ((info_lekce[i - 1].zavislost_na > MAXTEST) ||
                (info_lekce[i - 1].zavislost_na < 0))
                info_lekce[i - 1].zavislost_na = MAXTEST;
        }
    } while ((i < MAXLEKCE) && !feof(soubor));

    fclose(soubor);
    return 0;
}

int nacti_info_vsecky_test()
{
    FILE *soubor;
    unsigned int i;

    for (i = 0; i < MAXTEST; i++) {
        /* toto musi byt nazacatku (pred prvnim return) */
        info_test[i].test = 1;  /* je to test */
        info_test[i].komentar = (char *) malloc(SIZEKOMENTAR);
        if (info_test[i].komentar == NULL)
            info_lekce[i].komentar = temp;
        info_test[i].klavesy = (char *) malloc(SIZEKLAVESY);
        if (info_test[i].klavesy == NULL)
            info_lekce[i].klavesy = temp;
        info_test[i].pismena = (char *) malloc(SIZEPISMENA);
        if (info_test[i].pismena == NULL)
            info_test[i].pismena = temp;
        info_test[i].nove_pismena = (char *) malloc(SIZENOVEPISMENA);
        if (info_test[i].nove_pismena == NULL)
            info_lekce[i].nove_pismena = temp;
        info_test[i].zavislost_na = MAXLEKCE;
    }
    if ((soubor = fopen(jmeno_info_testu(), "rt")) == NULL)
        return 1;

    do {
        if (!fscanf(soubor, "%255s", temp))
            return 1;
        if (strcmp("cislo:", temp))
            continue;
        if (!fscanf(soubor, "%4u", &i))
            return 1;
        if ((i > 0) && (i <= MAXTEST) && !feof(soubor)) {
            info_test[i - 1].cislo = i;
            if (nacti_info_jedno(soubor, &info_test[i - 1])) {
                fclose(soubor);
                return 1;
            }
            if ((info_test[i - 1].zavislost_na > MAXLEKCE) ||
                (info_test[i - 1].zavislost_na < 0))
                info_test[i - 1].zavislost_na = MAXLEKCE;
        }
    } while ((i < MAXTEST) && !feof(soubor));

    fclose(soubor);
    return 0;
}

int nacti_info_vsecky()
{
    printf("Nacitam informace o lekcich a testech.\n");
    if (nacti_info_vsecky_lekce()) {
        fprintf(stderr, "Nelze nacist informace o lekcich!\n");
        return 1;
    }
    if (nacti_info_vsecky_test()) {
        fprintf(stderr, "Nelze nacist informace o testech!\n");
        return 1;
    }
    return 0;
}

void smaz_info_vsecky()
{
    unsigned int i;
    for (i = 0; i < MAXLEKCE; i++) {
        free(info_lekce[i].komentar);
        free(info_lekce[i].klavesy);
        free(info_lekce[i].pismena);
        free(info_lekce[i].nove_pismena);
    }
    for (i = 0; i < MAXTEST; i++) {
        free(info_test[i].komentar);
        free(info_test[i].klavesy);
        free(info_test[i].pismena);
        free(info_test[i].nove_pismena);
    }
}
#endif

int nacti_info_jedno(FILE * soubor, type_informace * L)
{
    char temp[255];
    unsigned short int i, j;
    if (6 != fscanf
        (soubor, "%10s%4u%4u%4u%4u%4u", temp, &L->presnost[0],
         &L->presnost[1], &L->presnost[2], &L->presnost[3],
         &L->presnost[4]))
        return 1;
    if (strcmp("presnost:", temp))
        return 1;

    if (6 != fscanf
        (soubor, "%10s%4u%4u%4u%4u%4u", temp, &L->rychlost[0],
         &L->rychlost[1], &L->rychlost[2], &L->rychlost[3],
         &L->rychlost[4]))
        return 1;
    if (strcmp("rychlost:", temp))
        return 1;

    if (!fscanf(soubor, "%11s%4i", temp, &L->zavislost_na))
        return 1;
    if (strcmp("zavislost:", temp))
        return 1;
    if (!fscanf(soubor, "%10s%4i", temp, &L->mezernik))
        return 1;
    if (strcmp("mezernik:", temp))
        return 1;
    if (!fscanf(soubor, "%100s", temp))
        return 1;
    if (strcmp("komentar:", temp))
        return 1;
    if (!fgets(L->komentar, SIZEKOMENTAR, soubor))
        return 1;
    L->komentar[strlen(L->komentar) - 1] = '\0';

    if (!fscanf(soubor, "%9s", temp))
        return 1;
    if (strcmp("klavesy:", temp))
        return 1;
    if (!fgets(L->klavesy, SIZEKLAVESY, soubor))
        return 1;
    if (!fscanf(soubor, "%160s", L->pismena))
        return 1;
/*    strncat(L->klavesy, temp, SIZEKLAVESY); */

    if (!fscanf(soubor, "%14s", temp))
        return 1;
    if (strcmp("nove_pismena:", temp))
        return 1;

    if (!fgets(L->nove_pismena, SIZENOVEPISMENA, soubor))
        return 1;

    j = 0;
    for (i = 0; i < strlen(L->nove_pismena); i++) {
        if ((L->nove_pismena[i] != ' ') && (L->nove_pismena[i] != '\n')
            && (L->nove_pismena[i] != '\t'))
            j = 1;
        else if (L->nove_pismena[i] == '\n')
            L->nove_pismena[i] = '\0';
    }
    if (!j)
        strcpy(L->nove_pismena, "");

    return 0;
}

int nacti_info(int l, type_informace * L, char *jmeno_soub)
{
#ifndef PSANIPROFI
    FILE *soubor;
    char temp[255];
#endif
    static char komentar[SIZEKOMENTAR];
    static char klavesy[SIZEKLAVESY];
    static char pismena[SIZEPISMENA];
    static char nove_pismena[SIZENOVEPISMENA];

    /* toto musi byt nazacatku (pred prvnim return) */
    if (strcmp(jmeno_soub, jmeno_info_testu()))
        L->test = 0;            /* je to test */
    else
        L->test = 1;            /* je to lekce */
    L->komentar = komentar;
    L->klavesy = klavesy;
    L->pismena = pismena;
    L->nove_pismena = nove_pismena;
    strcpy(L->komentar, "");
    strcpy(L->klavesy, "");
    strcpy(L->pismena, "");
    strcmp(L->nove_pismena, "");
    L->zavislost_na = (MAXLEKCE > MAXTEST) ? MAXLEKCE : MAXTEST;
#ifdef PSANIPROFI
    if (strcmp(jmeno_soub, jmeno_info_testu()))
        *L = info_lekce[l - 1];
    else
        *L = info_test[l - 1];
    return 0;
#else
    if ((soubor = fopen(jmeno_soub, "rt")) == NULL)
        return 1;

    do {
        if (feof(soubor))
            return 1;
        if (!fscanf(soubor, "%255s", temp))
            return 1;
        if (strcmp("cislo:", temp))
            continue;
        if (!fscanf(soubor, "%4i", &L->cislo))
            return 1;
        if (L->cislo == l)
            break;
    } while (1);

    if (nacti_info_jedno(soubor, L)) {
        fclose(soubor);
        return 1;
    }

    fclose(soubor);
    return 0;
#endif
}
