/* Copyright (c) 2002 Petr Bilek
   Tento kod je volne programove vybaveni; muzete jej sirit a modifikovat
podle ustanoveni Obecne verejne license GNU, vydavane FreeSoftware Foundation.
Na tento program se nevztahuji ZADNE ZARUKY; neposkytuji se ani odvozene zaruky
PRODEJNSTI anebo VHODNOSTI PRO URCITY UCEL. */
/* soubor nactislozku.c */

#include <sys/stat.h>
#include <dirent.h>
#include <time.h>
#include <stdlib.h>
#include <limits.h>
#include <string.h>
#include <errno.h>
#include "definice.h"
#include "struktury.h"
#include "lib.h"

int otevri_adresar(char **chyba)
{
    DIR *adresar;
    *chyba = " Nelze otevt adres s nastavenm";

    if ((adresar = opendir(jmeno_adresare())) == NULL) {
        if (global_get(g_warning) == g_w_ano) {
            fprintf(stderr, "opendir(%s):", jmeno_adresare());
            perror(NULL);
        }
        if (pbadresar()) {
            if (global_get(g_warning) == g_w_ano) {
                fprintf(stderr, "Nelze otevt adres \"%s\"\n"
                        "\n(nebo nkter jeho pedchoz adres)\n",
                        jmeno_adresare());
            }
            return 1;
        }

        if ((mkdir(jmeno_adresare_psani(), S_IRUSR | S_IWUSR | S_IXUSR |
                   S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH)) != 0) {
            if (global_get(g_warning) == g_w_ano) {
                fprintf(stderr, "mkdir(%s):", jmeno_adresare_psani());
                perror(NULL);
                fprintf(stderr, "Nelze otevt adres \"%s\"\n"
                        "\n(nebo nkter jeho pedchoz adres)\n",
                        jmeno_adresare_psani());
            }
        }

        if ((mkdir(jmeno_adresare(), S_IRUSR | S_IWUSR | S_IXUSR |
                   S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH)) != 0) {
            if (global_get(g_warning) == g_w_ano) {
                fprintf(stderr, "mkdir(%s):", jmeno_adresare());
                perror(NULL);
                fprintf(stderr, "Nelze vytvoit adres \"%s\"\n",
                        jmeno_adresare());
            }
            return 1;
        }
    } else
        closedir(adresar);
    return 0;
}

int nacti_slozku(type_uziv * slozka, char **chyba)
{
    int i, j;
    FILE *soubor;

    *chyba = "Nelze otevt sloku s daty uivatele";

    if ((soubor = fopen(jmeno_souboru(), "rb")) == NULL) {
        if ((soubor = fopen(jmeno_souboru(), "wb")) == NULL) {
            if (global_get(g_warning) == g_w_ano) {
                perror("fopen()");
                fprintf(stderr, "Nelze st soubor %s\n", jmeno_souboru());
            }
            return 1;
        }

        strncpy(slozka->verse, SVER,
                sizeof(slozka->verse) / sizeof(slozka->verse[0]));
        for (i = 0; i < MAXLEKCE; i++) {
            slozka->napsano_lekce[i] = 0;       /*1;  0 */
            slozka->napsano_odstavec[i] = 0;    /* ODSTAVEC;  0 */
        }

        for (i = 0; i < MAXTEST; i++) {
            slozka->napsano_test[i] = 0;        /* 1;    0 */
            for (j = 0; j < POKUSU; j++)
                slozka->datum_test[j][i] = (time_t) 0;
        }

        slozka->jmeno[0] = '\0';
        slozka->heslo[0] = '\0';
        srand((unsigned) time(NULL));
        slozka->heslo_I = (unsigned int) rand();


        if (fwrite(slozka, sizeof(type_uziv), 1, soubor) <= 0) {
            if (global_get(g_warning) == g_w_ano) {
                perror("fwrite");
                fprintf(stderr, "Nelze zapsat slozku %s\n",
                        jmeno_souboru());
            }
            return 1;
        }
        if (chmod(jmeno_souboru(), S_IRUSR | S_IWUSR))
            perror("chmod()");

        if (fclose(soubor) && (global_get(g_warning) == g_w_ano)) {
            perror("fclose()");
            return 1;
        }
        return 2;               /* prvni spusteni programu */
    }

    if (fread(slozka, sizeof(type_uziv), 1, soubor) != 1 ||
        strcmp(slozka->verse, SVER)) {
        if (fclose(soubor) && (global_get(g_warning) == g_w_ano))
            perror("fclose()");
        if (strcmp(slozka->verse, SVER) &&
            (global_get(g_warning) == g_w_ano))
            fprintf(stderr, "Chybn verze souboru \"%s\"\nVerze m bt %s,"
                    "ale je \"%s\"\n", jmeno_souboru(), SVER,
                    slozka->verse);
        else if (global_get(g_warning) == g_w_ano)
            fprintf(stderr, "Nepodarilo se nacist vsechna data ze souboru"
                    " \"%s\"\n", jmeno_souboru());

        return 1;
    }
    if (fclose(soubor) && (global_get(g_warning) == g_w_ano))
        perror("fclose()");
    return 0;
}

void implicitni_nastaveni(type_nastaveni * nastaveni)
{
    int i;
    int presnost[5] = { 20, 40, 70, 90, 110 };
    int rychlost[5] = { 111, 96, 76, 61, 41 };

    strncpy(nastaveni->verse, NVER,
            sizeof(nastaveni->verse) / sizeof(nastaveni->verse[0]));
    nastaveni->metronom = -80;

    for (i = 0; i < 5; i++) {
        nastaveni->vtext.rychlost[i] = rychlost[i];
        nastaveni->vtext.presnost[i] = presnost[i];
    }
    nastaveni->vtext.test = 0;
    nastaveni->vtext.mezernik = 1;

    nastaveni->qwertz = 1;      /* predpoklada se, ze je klavesnice qwertz */
    nastaveni->us = 0;          /* nastavuje se ceska klavesnice */
    global_set(g_qwertz, g_q_z);
    global_set(g_us, g_us_cz);
    nastaveni->spusteno = 0;
}

int nacti_nastaveni(type_nastaveni * nastaveni, char **chyba)
{
    FILE *soubor;

    *chyba = "Nelze otevt sloku s nastavenm uivatele";

    if ((soubor = fopen(jmeno_souboru_nastaveni(), "rb")) == NULL) {
        if ((soubor = fopen(jmeno_souboru_nastaveni(), "wb")) == NULL) {
            if (global_get(g_warning) == g_w_ano) {
                perror("fopen()");
                fprintf(stderr, "Nelze st soubor %s",
                        jmeno_souboru_nastaveni());
            }
            return 1;
        }
        implicitni_nastaveni(nastaveni);

        if (fwrite(nastaveni, sizeof(type_nastaveni), 1, soubor) <= 0) {
            if (global_get(g_warning) == g_w_ano) {
                perror("fwrite");
                fprintf(stderr, "Nelze zapsat slozku %s",
                        jmeno_souboru_nastaveni());
            }
            return 1;
        }
        if (chmod(jmeno_souboru_nastaveni(), S_IRUSR | S_IWUSR))
            perror("chmod()");

        if (fclose(soubor) && (global_get(g_warning) == g_w_ano)) {
            perror("fclose()");
        }
        return 2;               /* prvni spusteni */
    }
    /* podarilo se otevrit pro cteni */
    if (fread(nastaveni, sizeof(type_nastaveni), 1, soubor) != 1 ||
        strcmp(nastaveni->verse, NVER)) {
        if (fclose(soubor) && (global_get(g_warning) == g_w_ano))
            perror("fclose()");
        if (strcmp(nastaveni->verse, NVER) &&
            (global_get(g_warning) == g_w_ano))
            fprintf(stderr, "Chybn verze souboru \"%s\"\nVerze m bt %s,"
                    "ale je \"%s\"\n", jmeno_souboru_nastaveni(), NVER,
                    nastaveni->verse);
        else if (global_get(g_warning) == g_w_ano)
            fprintf(stderr, "Nepodarilo se nacist vsechna data ze souboru"
                    " \"%s\"\n", jmeno_souboru_nastaveni());
        implicitni_nastaveni(nastaveni);
        return 1;
    }
    if (fclose(soubor) && (global_get(g_warning) == g_w_ano))
        perror("fclose()");
    return 0;
}
